Option Explicit

Declare Function SHGetSpecialFolderPathA Lib "shell32.dll" ( _
	ByVal hwndOwner As Long, _
	ByVal lpszPath As String, _
	ByVal csidl As Long, _
	ByVal fCreate As Long) As Long

'Returns:   Zero if it failes, non-zero if successful.
'Parameter:
'hwndOwner  Reserved (0!)
'lpszPath   [out] A pointer to a null-terminated string that receives the
'           drive and path of the specified folder. This buffer must be at
'           least MAX_PATH characters in size.
'csidl      [in] A CSIDL that identifies the folder of interest. If a
'           virtual folder is specified, this function will fail.
'fCreate    [in] Indicates whether the folder should be created if it does
'           not already exist. If this value is nonzero, the folder will be
'           created. If this value is zero, the folder will not be created.

Const MAX_PATH& = &H104	'Maximale Lnge eines Dateipfades

Sub Main
	Dim strPath$, csidl%, retval$
	'Genug Platz reservieren fr Rckgabewert
	strPath = Space(MAX_PATH)
	For csidl = 1 To &H3F
		retval = SHGetSpecialFolderPathA(0, strPath, csidl, 0)
		If retval > 0 Then
			Print "&H" & Right("00" & Hex(csidl), 2),"=", strPath
		Else
			Print "&H" & Right("00" & Hex(csidl), 2),"= FEHLER ! =", strPath
		End If
	Next
End Sub


'Allgemein:
'----------
'Const MAX_PATH& = &H104	'Maximale Lnge eines Dateipfades
'Const CSIDL_FLAG_CREATE& = &H8000	'(Win 2000) Falls das Verzeichnis nicht Eistiert wird es erstellt
'Const CSIDL_FLAG_DONT_VERIFY& = &H4000	'(Win 2000) Benutzt den Ordner auch wenn der CSIDL nicht existiert
'Fr csidl:
'----------
'Const CSIDL_ADMINTOOLS& = &H30	'(Win 2000) "Administrations Tools"
'Const CSIDL_ALTSTARTUP& = &H1D	'"Alternatives Startverzeichnis"
'Const CSIDL_APPDATA& = &H1A	'"AppData"
'Const CSIDL_BITBUCKET& = &HA	'"Papierkorb"
'Const CSIDL_CDBURN_AREA& = &H3B	'"CD Burning"
'Const CSIDL_COMMON_ADMINTOOLS& = &H2F	'(Win 2000) "Administartions Tools fr alle Benutzer"
'Const CSIDL_COMMON_ALTSTARTUP& = &H1D	'(Win 2000) "Alternatives Startverzeichnis fr alle Benutzer"
'Const CSIDL_COMMON_APPDATA& = &H23	'"AppData fr alle Benutzer"
'Const CSIDL_COMMON_DESKTOPDIRECTORY& = &H19	'"Desktop fr alle Benutzer"
'Const CSIDL_COMMON_DOCUMENTS& = &H2E	'"Dokumente fr alle Benutzer"
'Const CSIDL_COMMON_FAVORITES& = &H1F	'"Favoriten fr alle Benutzer"
'Const CSIDL_COMMON_MUSIC& = &H35	'"All Users\Meine Musik"
'Const CSIDL_COMMON_PICTURES& = &H36	'"All Users\Meine Bilder"
'Const CSIDL_COMMON_PROGRAMS& = &H17	'"Startmen/Programme fr alle Benutzer"
'Const CSIDL_COMMON_STARTMENU& = &H16	'"Startmen fr alle Benutzer"
'Const CSIDL_COMMON_STARTUP& = &H18	'"Startmen/Autostart fr alle Benutzer"
'Const CSIDL_COMMON_TEMPLATES& = &H2D	'"All Users\Vorlagen"
'Const CSIDL_COMMON_VIDEO& = &H37	'"All Users\Meine Videos"
'Const CSIDL_CONTROLS& = &H3	'"Systemsteuerung"
'Const CSIDL_COOKIES& = &H21	'"Cookies"
'Const CSIDL_DESKTOP& = &H0	'"Desktop"
'Const CSIDL_DESKTOPDIRECTORY& = &H10	'"Desktop-Verzeichnis"
'Const CSIDL_DRIVES& = &H11	'"Arbeitsplatz"
'Const CSIDL_FAVORITES& = &H6	'"Favoriten"
'Const CSIDL_FONTS& = &H14	'"Fonts"
'Const CSIDL_HISTORY& = &H22	'"History"
'Const CSIDL_INTERNET& = &H1	'"Internet"
'Const CSIDL_INTERNET_CACHE& = &H20	'"Internet Cache"
'Const CSIDL_LOCAL_APPDATA& = &H1C	'(ab IE 5.0) "Local AppData"
'Const CSIDL_MYMUSIC& = &HD	'(ab IE 5.0) "Eigene Musik"
'Const CSIDL_MYPICTURES& = &H27	'(ab IE 5.0) "Eigene Bilder"
'Const CSIDL_MYVIDEO& = &HE	'(ab IE 5.0) "Eigene Videos"
'Const CSIDL_NETHOOD& = &H13	'"Netzwerkumgebung"
'Const CSIDL_NETWORK& = &H12	'"Gesamtes Netzwerk"
'Const CSIDL_PERSONAL& = &H5	'"Eigene Dokumente #############################################"
'Const CSIDL_PRINTERS& = &H4	'"Drucker"
'Const CSIDL_PRINTHOOD& = &H1B	'"Drucker-Verzeichnis"
'Const CSIDL_PROFILE& = &H28	'(ab IE 5.0) "Profile"
'Const CSIDL_PROGRAM_FILES& = &H26	'(ab IE 5.0) "Programme"
'Const CSIDL_PROGRAM_FILES_COMMON& = &H2B	'"Programme fr alle Benutzer"
'Const CSIDL_PROGRAM_FILES_COMMONX86& = &H2C	'(Win 2000 - x86) "Programme fr alle Benutzer"
'Const CSIDL_PROGRAM_FILESX86& = &H2A	'(Win 2000 - RISC) "Programme fr alle Benutzer"
'Const CSIDL_PROGRAMS& = &H2	'"Startmen/Programme"
'Const CSIDL_RECENT& = &H8	'"Startmen/Dokumente"
'Const CSIDL_SENDTO& = &H9	'"Senden an"
'Const CSIDL_STARTMENU& = &HB	'"Startmen"
'Const CSIDL_STARTUP& = &H7	'"Autostart"
'Const CSIDL_SYSTEM& = &H25	'(ab IE 5.0) "System"
'Const CSIDL_SYSTEMX86& = &H29	'(Win 2000) "Systemx86"
'Const CSIDL_TEMPLATES& = &H15	'"Templates"
'Const CSIDL_WINDOWS& = &H24	'(ab IE 5.0) "Windows"
